/*  GTKtalog.
 *  Copyright (C) 1999  Mathieu VILLEGAS
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <regex.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/mtio.h>
#include <linux/cdrom.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>

#include "data.h"
#include "erreur.h"
#include "addisk.h"
#include "edit.h"
#include "waitbox.h"
#include "fastaddisk.h"
#include "interface.h"

#ifdef LIBC5
#define SIGUSR1 SIGSTKFLT
#define SIGUSR2 SIGUNUSED
#endif

GtkWidget *name_entry;

Folder temp_racine;
int updated_disk;
pthread_t thread2;
int fast_scan_error;


void finish_update()
{
  void *ret;

  if(pthread_join(thread2,&ret) == 28) printf("pouet\n");
  if(fast_scan_error == -1)
    {
      erreur_dialog(NULL, "Disk already mounted", "or bad argument in setup", "ERROR: Mount failed.");
      return;
    }
  if(fast_scan_error == -2)
    {
      erreur_dialog(NULL, "Can't umount disk", "Check if it's not in use", "Warning!");
    }

  change_name(&racine.folders[racine.nb_folders -1],racine.folders[updated_disk].name);
  racine.folders[racine.nb_folders -1].type = 1;//is_a_disk;

  //free_folder(&racine.folders[updated_disk]);

  racine.folders[updated_disk] = racine.folders[racine.nb_folders -1];
  racine.nb_folders--;
  racine.folders = (Folder*) realloc(racine.folders,(racine.nb_folders)*sizeof(Folder));

  is_modified = 1;
  update_tree();
  close_waitbox();

  list_folder(&racine.folders[updated_disk]);
}



void *start_update_disk(void *arg/*GtkWidget *w, gpointer data*/)
{
  char temp[]="";
  
  if(mount_disk() == -1)
    {
      //erreur_dialog(name_entry, "Mount failed", "Bad parameters or CD already mounted", "ERROR !!!!");
      fast_scan_error = -1;
      kill(current_pid,SIGUSR1);
      if(waitbox_is_open == 1) kill(current_pid,SIGALRM);
      else waitbox_is_open = -1;
      pthread_exit(0);
    }
  
  //on commence a charger l'arborescence
  disk_path_size = strlen(mount_point);
  chdir(mount_point);
  if (racine.nb_folders == 0) racine.folders = (Folder*) malloc(sizeof(Folder));
  else racine.folders = (Folder*) realloc(racine.folders,(racine.nb_folders+1)*sizeof(Folder)); 
  init_folder(&racine.folders[racine.nb_folders],&racine,mount_point,0,0,0);
  create_folder_tree(&racine.folders[racine.nb_folders],temp);
  racine.nb_folders++;
  //fin de parcour de l'arborescence
  chdir(getenv("HOME"));

  if(umount_disk() == -1)
    {
      //erreur_dialog(name_entry, "Umount failed", "Disk in use?", "ERROR !");
      fast_scan_error = -2;
      kill(current_pid,SIGUSR1);
      if(waitbox_is_open == 1) kill(current_pid,SIGALRM);
      else waitbox_is_open = -1;
      pthread_exit(0);
    }
  eject_disk();
  is_modified = 1;
  
/*  while(waitbox_is_open == 0)
    {
      //j'attends! Faut ecrire plus vite le nom du disque aussi!
      // Pff! c'est boulets qui mettent deux heures a chercher 
      //leurs touches obligent  faire de ces trucs!
    }*/

  kill(current_pid,SIGUSR1);

  pthread_exit(0);
  exit(0);
}





void update_disk(GtkWidget *w, gpointer data)
{
  int i;

  fast_scan_error = 0;
  
  for(i=0;i<racine.nb_folders;i++)
    {
      if(strcmp(racine.folders[i].name,selected_folder->name) == 0)
	{
	  updated_disk = i;
	  break;
	}
    }

  if(pthread_create(&thread2, NULL,start_update_disk , NULL) <0)
    {
      erreur_dialog(data, "Thread failed", "Check your number of threads.", "ERROR !");
      return;
    }
  
  signal(SIGUSR2,update_waitbox); 
  signal(SIGALRM,close_waitbox);

  chdir(getenv("HOME"));
  open_waitbox();
  signal(SIGUSR1,finish_update);
}

